\section{Extend application range}

The application of \approachName to hashtag dissemination requires addressing some open challenges.
In \cite{chepin}, we do not control the size of generations, i.e. groups of messages that are encoded together.
When the message rate is too low, CHEPIN behaves similarly to \textsc{Pulp}\cite{felber_pulp:_2012}, a state of the art algorithm from which \approachName is inspired that doesn’t use network coding.
When the message rate is too high, decoding complexity can explode due to too many messages being put in the same generation.
However, experiments in \cite{chepin} show that with network parameters corresponding to an average server on the Internet, it would require a very high message rate.

Still, to cope with the uncertainty of real world systems and to maximize bandwidth efficiency,
we can act on the generation sizes via the configuration of
our Lamport Timestamps logic. More specifically, we need
to redefine what should be considered as "an event". In the
presented solution, we consider that forwarding a message or
emitting a new message is an event. To increase the size of
the generation, we can raise an event every $k$ ($k > 1, k \in \mathbb{N}$)
forwarded message or new message sent.

To reduce generation sizes, we can choose to split the nodes
in $g$ ($g > 1, g \in \mathbb{N}$) different clusters. Each node clock can be
initialized with a random value $i \in [0, g]$. Each time a node
forwards a message or sends a new message, it is considered
as g events. The initial clock setup enables to create group of
nodes that will emit messages that will be forwarded by the
whole network but that will be encoded only with messages
of their group.

We have alredy done some experiments with this algorithm
successfully reducing and increasing generation sizes as in-
tended. Now, we would like to extend this work to target a
specific generation size and automatically adapt our protocol
configuration to maintain this size as the network parameters
evolve.
